# coding: utf-8
require 'csv'

SVG_TEMPLATE = <<-EOS
<?xml version="1.0" encoding="utf-8"?>
<svg version="1.1" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" x="0px" y="0px"
   viewBox="0 0 178.58 249.45" style="enable-background:new 0 0 178.58 249.45;" xml:space="preserve">
<style type="text/css">
  .st0{fill:XXXCOLOR1;}
  .st1{fill:XXXCOLOR2;}
  .st2{fill:none;stroke:#343554;stroke-width:2;stroke-miterlimit:10;}
  .st3{fill:#343554;}
  .st4{font-family:'KozGoPr6N-Regular-83pv-RKSJ-H';}
  .st5{font-size:20px;}
  .st6{font-size:22px;}
</style>
  <rect class="st0" width="178.58" height="249.45"/>
  <polygon class="st1" points="0,0 89.38,125.16 0,249.45"/>
  <polygon class="st1" points="178.58,0 89.38,125.16 178.58,249.45"/>
  <rect class="st2" width="178.58" height="249.45"/>
  <text transform="matrix(1 0 0 1 9.324 27.8)" class="st3 st4 st5">XXXタイミング XXXコスト</text>
  <text transform="matrix(1 0 0 1 9.324 235.2)" class="st3 st4 st6">XXXパワー</text>
  <text transform="matrix(1 0 0 1 146.1839 235.1997)" class="st3 st4 st6">XXXスマッシュ</text>
  <text transform="matrix(1 0 0 1 9.324 73.5976)" class="st3 st4 st6">XXXカード名0</text>
  <text transform="matrix(1 0 0 1 9.324 103.7001)" class="st3 st4 st6">XXXカード名1</text>
  <text transform="matrix(1 0 0 1 9.324 133.8032)" class="st3 st4 st6">XXXカード名2</text>
  <text transform="matrix(1 0 0 1 9.324 163.9059)" class="st3 st4 st6">XXXカード名3</text>
  <text transform="matrix(1 0 0 1 9.324 207.2795)" class="st3 st4 st5">XXX種別</text>
</svg>
EOS

OUTPUT_DIR = "output_images/"

RED = "#F3CECE"
BLACK = "#DCCEE5"
BLUE = "#D8ECEF"
WHITE ="#F5F3D5"
GREEN = "#CADAC9"
CLEAR = "#F2F2F2"

i = 0
keys = Array::new
#CSV.foreach('db/adjusted_d0cardlist.csv',encoding: "Shift_JIS:UTF-8") do |row|
CSV.foreach('adjusted_d0cardlist.csv',encoding: "UTF-8") do |row|
  if i==0 then
    #カードのパラメータの属性名を用意
    row.each do |r|
      keys << r
    end
    p keys
  else
    #カードデータの用意
    cardHash = Hash::new
    keys.each_with_index do |key,num|
      cardHash[key] = row[num]
    end
    #p cardHash["name"]
    #カードテンプレートの読み込み
    svg_data = SVG_TEMPLATE

    #各データを置換
    timing = cardHash["timing"].nil? ? "" : cardHash["timing"]
    if timing == "ノーマル" then
      svg_data = svg_data.gsub("XXXタイミング","N")
    elsif timing == "クイック" then
      svg_data = svg_data.gsub("XXXタイミング","Q")
    elsif timing == "バトル" then
      svg_data = svg_data.gsub("XXXタイミング","B")
    else
      svg_data = svg_data.gsub("XXXタイミング","")
    end

    svg_data = svg_data.gsub("XXXコスト",cardHash["play_cost"].nil? ? "" : cardHash["play_cost"])
    svg_data = svg_data.gsub("XXXパワー",cardHash["power"].nil? ? "" : cardHash["power"])
    svg_data = svg_data.gsub("XXXスマッシュ",cardHash["smash"].nil? ? "" : cardHash["smash"])
    svg_data = svg_data.gsub("XXX種別",cardHash["card_kind"].nil? ? "" : cardHash["card_kind"])

    name = cardHash["name"].nil? ? "" : cardHash["name"]
    #カード名を7文字ずつで分割
    splt_name = name.scan(/.{1,#{7}}/)
    for name_i in 0..3 do
      svg_data = svg_data.gsub("XXXカード名"+name_i.to_s,splt_name[name_i].nil? ? "" : splt_name[name_i])
    end

    #色の設定
    color1 = CLEAR
    color2 = CLEAR
    cc = cardHash["color"].nil? ? "" : cardHash["color"]
    case cc
    when "赤" then
      color1,color2 = RED,RED
    when "黒" then
      color1,color2 = BLACK,BLACK
    when "青" then
      color1,color2 = BLUE,BLUE
    when "白" then
      color1,color2 = WHITE,WHITE
    when "緑" then
      color1,color2 = GREEN,GREEN
    when "赤黒" then
      color1,color2 = RED,BLACK
    when "黒青" then
      color1,color2 = BLACK,BLUE
    when "青白" then
      color1,color2 = BLUE,WHITE
    when "白緑" then
      color1,color2 = WHITE,GREEN
    when "緑赤" then
      color1,color2 = GREEN,RED
    end
    svg_data = svg_data.gsub("XXXCOLOR1",color1)
    svg_data = svg_data.gsub("XXXCOLOR2",color2)

    #svg_data = svg_data.gsub("XXXタイミング",cardHash["timing"].nil? ? "" : cardHash["timing"])

    #ファイルの書き出し
    File.open(OUTPUT_DIR + "d0udona_"+i.to_s+".svg","w") do |file|
      file.puts(svg_data)
    end
  end

  i += 1
  #if i>50 then
  #  break
  #end
end